Summary: Multicast Group Communication Framework
Name: spread
Version: 5.0.1
Release: 2%{?dist}
License: BSD-style
URL: http://www.spread.org/
Source0: http://www.spread.org/download/spread-src-%{version}.tar.gz
Source1: spread.service
Source2: spread.sysconfig
Source3: spread.logrotate
Source4: spread.conf
Source5: spread.tmpfiles
Patch0: spread-src-5.0.1-mdv_conf.diff
Patch1: spread-src-5.0.1-less_spam_in_logfiles.diff
Patch2: spread-src-5.0.1-no_strip.diff
Requires(pre): shadow-utils
%{?systemd_requires}
BuildRequires: bison flex byacc
BuildRequires: systemd-units
BuildRequires: /usr/bin/perl
BuildRequires: groff-base

%description
Spread is a toolkit that provides a high performance messaging service that is
resilient to faults across external or internal networks. Spread functions as a
unified message bus for distributed applications, and provides highly tuned
application-level multicast and group communication support. Spread services
range from reliable message passing to fully ordered messages with delivery
guarantees, even in case of computer failures and network partitions. Spread is
designed to encapsulate the challenging aspects of asynchronous networks and
enable the construction of scalable distributed applications, allowing
application builders to focus on the differentiating components of their
application.

%package libs
Summary: Multicast Group Communication Framework library

%description libs
Spread is a toolkit that provides a high performance messaging service that is
resilient to faults across external or internal networks. Spread functions as a
unified message bus for distributed applications, and provides highly tuned
application-level multicast and group communication support. Spread services
range from reliable message passing to fully ordered messages with delivery
guarantees, even in case of computer failures and network partitions. Spread is
designed to encapsulate the challenging aspects of asynchronous networks and
enable the construction of scalable distributed applications, allowing
application builders to focus on the differentiating components of their
application.

%package devel
Summary: Development files for spread
Requires: %{name}-libs = %{version}-%{release}

%description devel
Spread is a toolkit that provides a high performance messaging service that is
resilient to faults across external or internal networks. Spread functions as a
unified message bus for distributed applications, and provides highly tuned
application-level multicast and group communication support. Spread services
range from reliable message passing to fully ordered messages with delivery
guarantees, even in case of computer failures and network partitions. Spread is
designed to encapsulate the challenging aspects of asynchronous networks and
enable the construction of scalable distributed applications, allowing
application builders to focus on the differentiating components of their
application.

This package includes the necessary files to develop systems with Spread.

%prep

%setup -q -n spread-src-%{version}
%patch0 -p1
%patch1 -p1
%patch2 -p1

# hakk
perl -pi -e "s|yyin\ |yyin_whatever\ |g" daemon/lex.yy.c

%build

%configure \
    --with-mantype=man \
    --with-pid-dir=/run/spread \
    --with-unix-socket-dir=/run/spread

%{__make} V=1 %{?_smp_mflags}

%install

%make_install

%make_install -C libspread-util

install -d %{buildroot}%{_sysconfdir}/{sysconfig,logrotate.d}
install -d %{buildroot}%{_unitdir}
install -d %{buildroot}%{_localstatedir}/log/spread
install -d %{buildroot}%{_prefix}/lib/tmpfiles.d
install -d %{buildroot}%{_localstatedir}/spread

install -m0644 %{SOURCE1} %{buildroot}%{_unitdir}/spread.service
install -m0644 %{SOURCE2} %{buildroot}%{_sysconfdir}/sysconfig/spread
install -m0644 %{SOURCE3} %{buildroot}%{_sysconfdir}/logrotate.d/spread
install -m0644 %{SOURCE4} %{buildroot}%{_sysconfdir}/spread.conf
install -m0644 %{SOURCE5} %{buildroot}%{_prefix}/lib/tmpfiles.d/spread.conf
install -m0644 docs/sample.spread.access_ip %{buildroot}%{_sysconfdir}/spread.access_ip


# create ghost file
touch %{buildroot}%{_localstatedir}/log/spread/spread.log

# delete installed docs
rm -rf %{buildroot}%{_datadir}/doc/spread
rm -rf %{buildroot}%{_datadir}/doc/libspread-util

%pre
getent group spread >/dev/null || groupadd -f -r spread
getent passwd spread >/dev/null || useradd -r -g spread -d /run/spread -s /sbin/nologin -c "spread user" spread
exit 0

%post
%systemd_post spread.service

%preun
%systemd_preun spread.service

%postun
%systemd_postun_with_restart spread.service

%post libs -p /sbin/ldconfig

%postun libs -p /sbin/ldconfig

%files
%license license.txt
%doc release_announcement_*.txt CVS_Readme.txt Readme.txt
%doc docs/DynamicConfiguration.txt docs/MultithreadedClients.txt docs/Short_Buffer_Handling.txt
%doc docs/PORTING docs/TODO
%config(noreplace) %{_sysconfdir}/spread.*
%config(noreplace) %{_sysconfdir}/sysconfig/spread
%config(noreplace) %{_sysconfdir}/logrotate.d/spread
%{_prefix}/lib/tmpfiles.d/spread.conf
%{_unitdir}/spread.service
%{_bindir}/flush_user
%{_bindir}/sp*
%{_sbindir}/spread
%{_mandir}/man1/*
%attr(0755,spread,spread) %dir %{_localstatedir}/log/spread
%attr(0644,spread,spread) %ghost %{_localstatedir}/log/spread/spread.log
%attr(0755,spread,spread) %dir %{_localstatedir}/spread

%files libs
%{_libdir}/libspread-core.so.3*
%{_libdir}/libtspread-core.so.3*
%{_libdir}/libspread.so.3*
%{_libdir}/libspread-util.so.5*

%files devel
%{_libdir}/lib*.so
%{_libdir}/lib*.a
%{_includedir}/*
%{_mandir}/man3/*

%changelog
* Sun Dec 25 2022 Oden Eriksson <oe@nux.se> 5.0.1-2
- synch with inhouse changes:
 - compress rotated logs as they tend to be huge
 - fix build on RHEL 9
 - P2: provide debug symbols
 - P1: less spam in logfiles
 - add tmp files structure
 - adapt for systemd
 - P0: fix various broken logic
 - also package the static and libspread-util libraries
 - BR: perl, groff-base

* Thu Feb 11 2021 Oden Eriksson <oe@nux.se> 5.0.1-1
- bring back from the dead...

* Thu Oct 28 2010 Oden Eriksson <oeriksson@mandriva.com> 4.1.0-2mdv2011.0
+ Revision: 589738
- stupid build system

* Thu Oct 28 2010 Oden Eriksson <oeriksson@mandriva.com> 4.1.0-1mdv2011.0
+ Revision: 589707
- 4.1.0

* Mon Oct 05 2009 Oden Eriksson <oeriksson@mandriva.com> 4.0.0-3mdv2010.0
+ Revision: 454048
- rediffed one fuzzy patch
- rebuild

  + Thierry Vignaud <tv@mandriva.org>
    - rebuild

* Tue Oct 28 2008 Oden Eriksson <oeriksson@mandriva.com> 4.0.0-1mdv2009.1
+ Revision: 297851
- broke out the python module
- 4.0.0
- rediffed P0,P1

* Wed Jul 23 2008 Thierry Vignaud <tv@mandriva.org> 3.17.4-5mdv2009.0
+ Revision: 242733
- rebuild
- kill re-definition of %%buildroot on Pixel's request

  + Pixel <pixel@mandriva.com>
    - do not call ldconfig in %%post/%%postun, it is now handled by filetriggers

  + Olivier Blin <oblin@mandriva.com>
    - restore BuildRoot

* Wed Sep 19 2007 Guillaume Rousse <guillomovitch@mandriva.org> 3.17.4-3mdv2008.0
+ Revision: 90266
- rebuild

* Sun Sep 09 2007 Oden Eriksson <oeriksson@mandriva.com> 3.17.4-2mdv2008.0
+ Revision: 83634
- conform to the 2008 specs


* Fri Jan 26 2007 Oden Eriksson <oeriksson@mandriva.com> 3.17.4-1mdv2007.0
+ Revision: 114000
- fix a silly typo...
- fixed a typo in spread.init
- force doc format to man
- Import spread

* Fri Jan 26 2007 Oden Eriksson <oeriksson@mandriva.com> 3.17.4-1mdv2007.1
- 3.17.4

* Tue Dec 20 2005 Oden Eriksson <oeriksson@mandriva.com> 3.17.3-1mdk
- initial Mandriva package (conectiva import)
- added P0, P1
